-- Aufgabe Vorlesung PdfP, Frank Herklotz

module Umdrehen where

import Prelude hiding (reverse)

-- wir nehmen das als offensichtliche Definition
reverse :: [a] -> [a]
reverse [] = []				 -- (1)
reverse (x : xs) = reverse xs ++ [x]	 -- (2)

-- mit der wir die folgende (effizientere) Implementierung
-- vergleichen wollen
-- zu zeigen:  (3)  umdreh xs = reverse xs
umdreh :: [a] -> [a]
umdreh xs = stapel xs []    -- (4)


stapel :: [a] -> [a] -> [a]
-- zu zeigen:  (5)  stapel xs ys = reverse xs ++ ys
stapel [] ys = ys                        -- (6)
stapel (x : xs) ys = stapel xs (x : ys)  -- (7)


{- Beweise:

(3) folgt aus (4) und (5):

umdreh xs = stapel xs [] = reverse xs ++ [] = reverse xs

(5) folgt durch Induktion nach dem ersten Argument

stapel [] ys = ys = [] ++ ys = reverse [] ++ ys

stapel (x : xs) ys ) = stapel xs (x : ys) 
     = reverse xs ++ (x : ys) = reverse xs ++ [x] ++ ys
     =(2)= reverse (x : xs) ++ ys

-}

{- Aufgabe: zeige, da aus (1) und (2) folgt

(8)  reverse (reverse xs) = xs

benutze und beweise dazu einen geeigneten Hilfssatz

Beweis durch Induktion nach Anzahl der Elemente von xs:

IA:	reverse(reverse []) 	= reverse []	nach (1)
				= []		nach (1)
				
IS:	reverse(reverse(x:xs))	= reverse(reverse xs ++ [x])		nach (2)
				= reverse [x] ++ reverse(reverse xs)	nach (9), s.u.
				= [x] ++ xs				nach IV
				= (x : xs)				Eig. ++
				
benutzter Hilfssatz:

(9)  reverse(xs ++ [y]) = reverse [y] ++ reverse xs

Beweis durch Induktion nach Anzahl der Elemente von xs:

IA:	reverse([] ++ [y])	= reverse [y]				Eig. ++
				= [] ++ reverse	[y]			Eig. ++
				= reverse [] ++ reverse [y]		nach (1)
				
IS:	reverse((x:xs) ++ [y])	= reverse(([x] ++ xs) ++ [y])		Eig. []
				= reverse([x] ++ (xs ++ [y]))		Eig. ++
				= reverse(x : (xs ++ [y]))		Eig. []
				= reverse(xs ++ [y]) ++ [x]		nach (2)
				= reverse [y] ++ reverse xs ++ [x]	nach  IV
				= reverse [y] ++ reverse(x : xs)	nach (2)


Bem.:	der Beweis geht auch direkt durch sukzessives Aspalten von Elementen mittels (2),
	welche sich dann in "reverse" - Anordnung bzgl. ++ befinden,
	somit folgt dann auch die allgemeinere Variante:
	reverse(xs ++ ys) = reverse ys ++ reverse xs		(Endlichkeit der Mengen)

-}

-- HIDE
