module Arithmetik where

import Parser_Type
import Parser_Basic
import Parser_Combinators
import Rose

data Op = Plus | Minus | Mal | Durch 
     deriving (Eq, Ord, Show)

data Contents = Operator Op
	      | Constant Integer
     deriving (Eq, Ord, Show)

type Term = Rose Contents


pm :: Parser Op
pm =      fmap ( const Plus  ) ( unWhite $ match '+' )
   `plus` fmap ( const Minus ) ( unWhite $ match '-' )

md :: Parser Op
md =      fmap ( const Mal   ) ( unWhite $ match '*' )
   `plus` fmap ( const Durch ) ( unWhite $ match '/' )

falte :: Parser Op -> Parser Term -> Parser Term
falte sep p = do 
    x0 <- p
    sys <- many $ do s <- sep; y <- p; return (s, y)
    return $ foldl ( \ x (s, y) -> Node { key = Operator s
					, children = [ x, y ] } )
		   x0 sys

term :: Parser Term
term = summe

summe :: Parser Term
summe = falte pm produkt

produkt :: Parser Term
produkt = falte md atom

atom :: Parser Term
atom =    do n <- natural
	     return $ Node { key = Constant n, children = [] }
   `plus` paren term

