module Balance where

import Tree
import TFold

-- balance :  maximalen Unterschied 
--            zwischen Tiefe links und Tiefe rechts
-- d. h. bei AVL-Bumen ist -1 <= balance <= 1

balance :: Tree a -> Int
balance t = let (d, b) = depth_and_balance t in b

depth_and_balance :: Tree a -> (Int, Int)
depth_and_balance t = 
    tfold ( \ (dl, bl) k (dr, br) ->  -- HIDE
		     (1 + max dl dr, dl - dr) ) (0, 0)

