module Beat where

import FranTk

bpm :: Component
bpm = do
    first_click <- mkBVar 0.0
    last_click <- mkBVar 0.0
    clicks_so_far <- mkBVar 0.0
    average_bpm <- mkBVar 0.0

    let infos = mkLabel 
	      [ font (Font "10x20")
	      , textB $ lift1 ( \ x -> "average bpm : " ++ show x )
		      $ bvarBehavior average_bpm
	      ] 

    let timed listener = snapshotL time $ mapL ( \ ((), t) -> t ) $ listener

    let reset = mkButton [ text "reset" ]
	      ( timed
	      $ anyL [ input first_click
		     , input last_click
		     , tellL (input clicks_so_far) 0
		     , tellL (input average_bpm  ) 0
		     ] 
	      )

    let click = mkButton [ text "click" ]
	      ( timed
	      $ anyL [ input last_click
		     , tellL (bvarUpdInput clicks_so_far) (1 +)
		     , snapshotL ( bvarBehavior first_click )
		     $ snapshotL ( bvarBehavior clicks_so_far )
		     $ mapL ( \ ( (t, f), c ) -> (c + 1) * 60 / (t - f) )
		     $ input average_bpm
		     ]
	      )

    nbeside [ reset, infos, click ]


main :: IO ()
main = display $ do
         quit <- mkGUIL_ quit
         let men = mkMenu [] 
                 [ mcascade [text "file"] $ 
                   mkMenu [] [mbutton [text "quit"] quit]
                 ] 
         withRootWindow [title "bpm counter", useMenu men] bpm


