module Main (main) 
-- ein Hauptprogramm mu  main :: IO () exportieren
-- vergleiche  main ()  in einem C-Programm
where

import Prelude hiding (sequence, sequence_, (>>)) -- siehe unten

import IO -- openFile usw.
import System (getArgs)

cat :: String -> IO ()
cat fname = do

   -- die Typen stehen nur aus didaktischen Grnden dort
   h <- openFile fname ReadMode :: IO Handle

   -- liest alles auf einmal, aber lazy
   cs <- hGetContents h :: IO String

   -- schreibt auf stdout
   putStr cs :: IO ()

   hClose h

main = do
    argv <- getArgs :: IO [ String ]
    sequence_ [ cat arg | arg <- argv ]

-- Die Fuktion sequence_ steht eigentlich in der Prelude.
-- Wir definieren sie ber eine Variante von (>>=),
-- die das Ergebnis der ersten Rechnung ignoriert:

(>>) :: Monad m => m a -> m b -> m b
x >> y = x >>= const y

sequence_ :: Monad m => [ m a ] -> m ()
sequence_ = foldr (>>) (return ())

-- es gibt noch die Variante, die sich alle Ergebnisse merkt:
sequence :: Monad m => [ m a ] -> m [ a ]
sequence [] = return []
sequence (x : xs) = 
   do { z <- x; zs <- sequence xs; return (z : zs) }

