module Env

( Env   -- wird ohne Konstruktoren exportiert
, Envs
, nullEnvs
, mkEnv, find, finds
)

where

import FiniteMap -- das sind gewichtsbalancierte Bume

data Env a = Env (FiniteMap String a)
   deriving Show

type Envs a = [ Env a ]

mkEnv :: [ (String, a) ] -> Env a
mkEnv = Env . listToFM

nullEnvs :: Envs a
nullEnvs = []

find :: Env a -> String -> Maybe a
find (Env e) n = lookupFM e n

finds :: Envs a -> String -> Maybe a
-- die erste Bindung aus einer Liste von Umgebungen
finds es n =
    foldl (\ m e -> case m of
	      Just x -> Just x
	      Nothing -> find e n) Nothing es

