import Prelude  hiding (map, foldr, foldl)

map              :: (a -> b) -> [a] -> [b]
map f xs          = [ f x | x <- xs ]

foldr            :: (a -> b -> b) -> b -> [a] -> b
foldr f z []      = z
foldr f z (x:xs)  = f x (foldr f z xs)

foldl            :: (a -> b -> a) -> a -> [b] -> a
foldl f z []      = z
foldl f z (x:xs)  = foldl f (f z x) xs

reverse' = foldl (flip (:)) []

foldl'            :: (a -> b -> a) -> a -> [b] -> a
foldl' g 	  = flip ( foldr ( \ x h -> ( h . flip g x ) ) id )

reverse'' = foldl' (flip (:)) []


