module General_Parser_Type 

( GP (..), run

, MonadPlus (plus)
)

where

import MonadPlus

data GP m s a = GP ( [s] -> m (a, [s]) )

instance Monad m => Functor (GP m s) where
    fmap f (GP p) = GP $ \ input ->
	 do  (x, rest) <- p input 
	     return (f x, rest)

instance Monad m => Monad (GP m s) where
    return x = GP $ \ input -> return (x, input) 
    GP p >>= f = GP $ \ input -> do
	   (x, rest) <- p input
	   let GP q = f x
	   (y, rest') <- q rest
	   return (y, rest') 

instance MonadPlus m => MonadPlus (GP m s) where
    GP p `plus` GP q = GP $ \ input ->
        p input `plus` q input


run :: GP m s a -> [s] -> m (a, [s])
run (GP p) input = p input
