module Koordinaten 

( koordinaten, skaliere
)

where

import Winkel
import SOEGraphics (Point)


---------------------------------------------------------------------------

type Punkt = (Double, Double)
koordinaten :: Streckenzug i -> [ Punkt ]
koordinaten (Streckenzug ecken) = 
    koord 0.05 (0,0) [ w | ecke <- ecken, w <- alle ecke ]

-- durch Austausch der folgenden Funktion sollte man in die Lage kommen,
-- auch Parkettierungen in der hyperbolischen Ebene zu zeichnen!
-- man whlt einfach weiter oben Bausteine, deren Innenwinkelsumme
-- zu klein ist (z. b. ein Dreicke mit 3 * 45 Grad)
-- und rechnet dann einfach geradeaus weiter.

koord :: Winkel -> Punkt -> Winkels -> [ Punkt ]
-- aktuelle Richtung, aktuelle Position, Liste von Winkeln -> Punkte
koord w0 p0 [] = [ p0 ] -- Liste leer, wir kehren zum Anfangspunkt zurck
koord w0 p0 @ (x0, y0) (w : ws) =
    let alpha = 2 * pi * fromRational w0
	(dx, dy) = (cos alpha, sin alpha)
	p1 = (x0 + dx, y0 + dy)
	w1 = w0 + (w - 1%2) -- eventuell noch mod 1 reduzieren?
			    -- % ist der Konstruktor fr rationale Zahlen
    in	p0 : koord w1 p1 ws

skaliere :: Int -> [ Punkt ] -> [ Point ]
-- Point ist definiert in SOEGraphics als (Int, Int)
skaliere size ps = 
    let (xmin, xmax) = extreme [ x | (x,y) <- ps ]
	(ymin, ymax) = extreme [ y | (x,y) <- ps ]
	extreme zs = (minimum zs, maximum zs)    

	dx = xmax - xmin; dy = ymax - ymin
	d = max dx dy; f = fromInt size / d
	x0 = xmin - (d - dx) / 2; y0 = ymin - (d - dy) / 2

	-- was jetzt folgt, ist eine list comprehension    
    in  [ (round (f * (x - x0)), round (f * (y - y0))) 
	| (x, y) <- ps  -- das heit Generator
	]


