module Let_Parser 

( module Let_Parser
, parse
, final
)

where

import Let_Type
import Let_Form


-- das war die einfache Variante
-- import Parser

import Position_Parser

pm :: Parser Op
pm =      fmap ( const Plus  ) ( operator "+" )
   `plus` fmap ( const Minus ) ( operator "-" )

md :: Parser Op
md =      fmap ( const Mal   ) ( operator "*" )
   `plus` fmap ( const Durch ) ( operator "/" )

oder :: Parser Op
oder =    fmap ( const Oder  ) ( operator "|" )

falte :: Parser Op -> Parser Term -> Parser Term
falte sep p = do 
    x0 <- p
    sys <- many $ do s <- sep; y <- p; return (s, y)
    return $ foldl ( \ x (s, y) -> Apply s x y ) x0 sys

term :: Parser Term
term = alternative

alternative :: Parser Term
alternative = falte oder summe

summe :: Parser Term
summe = falte pm produkt

produkt :: Parser Term
produkt = falte md atom

atom :: Parser Term
atom =    do n <- natural
	     return $ Constant n
   `plus` paren term
   `plus` bindung
   `plus` do n <- name
	     return $ Var n

bindung :: Parser Term
bindung = do
    keyword "let"
    nts <- brace $ sepBy (operator ";")
		 $ do n <- name
		      operator "="
		      t <- term	
		      return (n, t)
    keyword "in"
    body <- term
    return $ Let nts body

