module Monadic_Inorder where

import Prelude hiding (return)

import State
import Tree
import Anamorph

inorder :: Tree a -> Tree Int
inorder t = run ( transform t )

transform :: Tree a -> State (Tree Int)
transform Leaf = return Leaf
transform (Node { left = l, right = r }) = 
    bind ( transform l ) $ \ hl ->
    bind ( next )        $ \ k  ->
    bind ( transform r ) $ \ hr ->
    return ( Node { left = hl, key = k, right = hr } )

return :: a -> State a
return x = State ( \ s -> (x, s) )

bind :: State a -> (a -> State b) -> State b
bind (State f) g = State ( \ s0 ->
    let (x, s1) = f s0 
	State h = g x
    in	h s1 )

