module Penrose 


( probiere
, module Koordinaten
)

where

import Winkel
import Kleben
import Correct
import Koordinaten

---------------------------------------------------------------------------


data Richtung = A | B | C | D
     deriving (Eq, Ord, Show)

data Penrose = Penrose { farbe :: Bool, richtung :: Richtung }
     deriving (Eq, Ord, Show)

wei    f = Penrose { farbe = True,  richtung = f }
schwarz f = Penrose { farbe = False, richtung = f }

-- die beiden Parkett-Bausteine
dnn :: Streckenzug Penrose
dnn = Streckenzug 
     [ Ecke { sichtbar = w % 10, alle = [ w % 10] 
	    , info = i }
     | (w, i) <- [ (1, map schwarz [A,C])
		 , (4, map schwarz [C,B])
		 , (1, map schwarz [B,D])
		 , (4, map wei    [D,A]) 
		 ]
     ]

dick :: Streckenzug Penrose
dick = Streckenzug 
     [ Ecke { sichtbar = w % 10, alle = [ w % 10] 
	    , info = i }
     | (w, i) <- [ (2, map wei    [D,A])
		 , (3, map schwarz [A,B])
		 , (2, map schwarz [B,C])
		 , (3, map schwarz [C,D]) 
		 ]
     ]

-------------------------------------------------------------------------

dnne = take 4 $ iterate drehe $ dnn
dicke = take 4 $ iterate drehe $ dick

drehe :: Streckenzug i -> Streckenzug i
drehe (Streckenzug (x : xs)) = Streckenzug (xs ++ [x])

---------------------------------------------------------------------------

instance Correct Penrose where
    correct xs =  and [ farbe (head xs) == farbe y | y <- tail xs ]
	       && paare (map richtung (tail xs))

paare (x : y : zs) =
      ((x,y) `elem` [(A,D),(D,A),(B,C),(C,B)]) && paare zs
paare [rest] = True
	 

---------------------------------------------------------------------------

prob ps q = q : do
     p  <- ps
     q' <- klebe q p
     prob ps q'

-- wird vom Hauptprogramm benutzt
probiere :: [ Streckenzug Penrose ]
probiere = do
    let  ps =  dicke ++ dnne 
    prob ps (head ps)

