module Position where

data Position = Position
     { zeile :: Int
     , spalte :: Int
     , inhalt :: String -- der gesamten Zeile
     }
     | EOF

instance Eq Position where
    EOF == EOF = True
    p @ Position {} == q @ Position {}  =  
	       (zeile p, spalte p) == (zeile q, spalte q)
    p == q  =  False

instance Ord Position where
    EOF `compare` EOF = EQ
    EOF `compare` q   = GT
    p `compare` EOF   = LT
    p `compare` q  =  (zeile p, spalte p) `compare` (zeile q, spalte q)


instance Show Position where
    showsPrec _ EOF = showString "Ende des Eingabestroms"
    showsPrec _ p @ Position { zeile = z, spalte = s, inhalt = i} = 
        let (vor, nach) = splitAt (s-1) i
	in  showString $
	    unlines [ "Zeile " ++ show z ++ ", Spalte " ++ show s
		    , vor 
		    , take (s-1) (repeat '^') ++  nach
		    ]

annotate :: String -> [ (Char, Position) ]
annotate input = concat
	       $ map annotate_line
	       $ zip [1..] 
	       $ map ( \ l -> l ++ "\n" ) 
	       $ lines input

annotate_line :: (Int, String) -> [ (Char, Position) ]
annotate_line (z, i) = do
    (s, c) <- zip [1..] i
    return $ ( c, Position { zeile = z, spalte = s, inhalt = i } )

    

