module Size where

import Prelude hiding (sum)



class Size a where size :: a -> Integer

instance Size Integer where size = const 1
instance Size Char    where size = const 1
instance Size Bool    where size = const 1

instance (Size a, Size b) => Size (a, b) where 
    size (x, y) = 1 + size x + size y

instance Size a => Size [a] where
    size = (+1) . sum . map size

sum = foldr (+) 0
