module TFold where

import Tree

-- Katamorphismus

tfold :: (b -> a -> b -> b) -> b -> (Tree a -> b)
tfold f z0 Leaf = z0
tfold f z0 (Node { left = l, key = k, right = r })
      =     f   (tfold f z0 l) k  (tfold f z0 r)

leaves = tfold ( \ l k r -> l +     r ) 1 
nodes  = tfold ( \ l k r -> l + 1 + r ) 0


flatten0 t = tfold ( \ l k r -> l ++ [k] ++ r ) [] t
flatten  t = tfold ( \ l k r -> l .  (k:) . r ) id t []

nodes1  = length . flatten





-- Hausaufgabe. Stelle als tfold dar
-- depth   :  maximale Tiefe
-- HIDE

depth :: Tree a -> Int
depth = tfold ( \ l k r -> 1 + max l r ) 0

