import Prelude hiding (zip, zipWith, iterate)

zip :: [a] -> [b] -> [(a,b)]
zip (x : xs) (y : ys) = (x,y) : zip xs ys
zip _ _ = []

zipWith :: (a -> b -> c) -> [a] -> [b] -> [c]
zipWith f (x : xs) (y : ys) = f x y : zipWith f xs ys
zipWith f _ _ = []

-- das htten wir auch schreiben knnen:

zip' = zipWith (,)

-- Beispiel: die Differenzenfolge einer Folge

diff :: [ Integer ] -> [ Integer ]
diff xs = zipWith (-) (tail xs) xs

quads :: [ Integer ]
quads = map ( ^ 2) [1 .. ]

-- Beispiel: das Pascalsche Dreieck

iterate          :: (a -> a) -> a -> [a]
iterate f x       = x : iterate f (f x)

pascal = iterate 
    ( \ zeile -> zipWith (+) 
			 ( [ 0 ] ++ zeile) 
			 (zeile ++ [ 0 ] )
    )
    [ 1 ]

